/*******************************************************************************
*  Statistics.cpp - how many of what?
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright(c) 2011 - BuckoSoft, Inc.
*
\*******************************************************************************/

#include "stdafx.h"
#include "../config.h"

#include <string>
#include <iostream>

#include <boost/regex.hpp>
using namespace boost;

#include "Statistics.h"
#include "TLine.h"

namespace berzerk {


///////////////////////////////////////////////////////////////////////////////
Statistics::Statistics() {
	this->linesRead = 0;
	this->ipsKilled = 0;
}

///////////////////////////////////////////////////////////////////////////////
void Statistics::incKilled(const string& ip, const string& rule, const string& deathLine, const regex& rex, const regex& rexip) {
	this->myMutex.lock();
	ipsKilled++;
	TLine tl = makeTLine(deathLine, rex, rexip);

	StatLine* sl = new StatLine(ip, rule, tl.toXML());
	set<string>::iterator iter;
	if ((iter = ipsKilledSet.find(ip)) == ipsKilledSet.end()) {
		ipsKilledSet.insert(ip);
		statLines.push_front(sl);
		if (statLines.size() > 20) {
			sl = statLines.back();
			statLines.pop_back();
			ipsKilledSet.erase(sl->ip);
			delete sl;
		}
	}
	this->myMutex.unlock();
}



}	// namespace berzerk
